/* Problem URL: https://codeforces.com/problemset/problem/1999/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;

const ll mod = 1e9 + 7;

constexpr int MAXN = 2e5 + 10;
ll fact[MAXN];
ll inv[MAXN];
ll invf[MAXN];

void pre()
{
    fact[0] = 1;
    nrep(i, 1, MAXN) {
        fact[i] = fact[i - 1] * i % mod;
    }

    inv[1] = 1;
    nrep(i, 2, MAXN) {
        inv[i] = (mod - mod / i) * inv[mod % i] % mod;
    }

    invf[0] = 1;
    nrep(i, 1, MAXN) {
        invf[i] = invf[i - 1] * inv[i] % mod;
    }
}

ll comb(ll n, ll k) {
    return fact[n] * invf[k] % mod * invf[n - k] % mod;
}

#define TEST 1

void solve()
{
    int n, k;
    cin >> n >> k;
    vi a(n);
    cin >> a;

    ll c0 = count(all(a), 0);
    ll c1 = count(all(a), 1);

    ll ans = 0;
    nrep(i, (k + 1) >> 1, k + 1) {
        ll o = i;
        ll z = k - i;

        if (c0 < z || c1 < o) {
            continue;
        }

        (ans += comb(c1, o) * comb(c0, z) % mod) %= mod;
    }
    
    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
